# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define section         free

Name:           ops4j-pax-exam
Summary:        Pax Exam OSGi testing
Url:            http://wiki.ops4j.org/display/paxexam/Pax+Exam
Version:        1.2.0
Release:        1%{?dist}
Epoch:          0
License:        Apache 2.0 License
Group:          Development/Libraries
Source0:        ops4j-pax-exam-1.2.0.tgz
# svn export https://scm.ops4j.org/repos/ops4j/qa/pax/exam-1.2.0/ ops4j-pax-exam-1.2.0
# tar czf ops4j-pax-exam-1.2.0.tgz ops4j-pax-exam-1.2.0/

Source1:        %{name}-settings.xml
Source2:        %{name}-jpp-depmap.xml

Patch0:         ops4j-pax-exam-container-default-pom.patch

BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  ant >= 0:1.7.1
BuildRequires:  maven2 >= 0:2.0.8
BuildRequires:  maven2-plugin-checkstyle
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-idea
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-plugin
BuildRequires:  maven2-plugin-release
BuildRequires:  maven2-plugin-remote-resources
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  apache-felix-maven-bundle-plugin
BuildRequires:  aries-testsupport
BuildRequires:  ops4j-pax-master
BuildRequires:  servicemix-depends-maven-plugin
BuildRequires:  testng

BuildRequires:  jline2
BuildRequires:  ops4j-base >= 0:1.2.2
BuildRequires:  ops4j-pax-construct
BuildRequires:  ops4j-pax-runner
BuildRequires:  ops4j-pax-scanner
BuildRequires:  ops4j-pax-swissbox
BuildRequires:  org.osgi.core
Requires(post):    jpackage-utils >= 0:1.7.5
Requires(postun):  jpackage-utils >= 0:1.7.5
Requires:  java >= 0:1.6.0
Requires:  jline2
Requires:  ops4j-base >= 0:1.2.2
Requires:  ops4j-pax-construct
Requires:  ops4j-pax-runner
Requires:  ops4j-pax-scanner
Requires:  ops4j-pax-swissbox
Requires:  org.osgi.core

BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-buildroot

%description
Pax Exam OSGi testing.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%prep
%setup -q 
chmod -R go=u-w *
for f in $(find . -name "*.jar"); do
  mv $f $f.no
done
cp %{SOURCE1} settings.xml
%patch0 -b .sav0

%build
sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml

export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

export SETTINGS=$(pwd)/settings.xml

mvn-jpp \
        -e \
        -s $SETTINGS \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        install 

mvn-jpp \
        -e \
        -s $SETTINGS \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Daggregate=true \
        javadoc:javadoc

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms

%add_to_maven_depmap org.ops4j.pax exam %{version} JPP/%{name} exam
install -m 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-exam.pom

%add_to_maven_depmap org.ops4j.pax.exam maven-archetype-paxexam-junit %{version} JPP/%{name} maven-archetype-paxexam-junit
install -m 644 maven-archetype-paxexam-junit/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-maven-archetype-paxexam-junit.pom
install -m 644 maven-archetype-paxexam-junit/target/maven-archetype-paxexam-junit-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/

%add_to_maven_depmap org.ops4j.pax.exam maven-paxexam-plugin %{version} JPP/%{name} maven-paxexam-plugin
install -m 644 maven-paxexam-plugin/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-maven-paxexam-plugin.pom
install -m 644 maven-paxexam-plugin/target/maven-paxexam-plugin-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/

%add_to_maven_depmap org.ops4j.pax.exam pax-exam-container-default %{version} JPP/%{name} pax-exam-container-default
install -m 644 pax-exam-container-default/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-pax-exam-container-default.pom
install -m 644 pax-exam-container-default/target/pax-exam-container-default-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/

%add_to_maven_depmap org.ops4j.pax.exam pax-exam-container-rbc-client %{version} JPP/%{name} pax-exam-container-rbc-client
install -m 644 pax-exam-container-rbc-client/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-pax-exam-container-rbc-client.pom
install -m 644 pax-exam-container-rbc-client/target/pax-exam-container-rbc-client-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/

%add_to_maven_depmap org.ops4j.pax.exam pax-exam-container-rbc %{version} JPP/%{name} pax-exam-container-rbc
install -m 644 pax-exam-container-rbc/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-pax-exam-container-rbc.pom
install -m 644 pax-exam-container-rbc/target/pax-exam-container-rbc-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/

%add_to_maven_depmap org.ops4j.pax.exam pax-exam-junit-extender-impl %{version} JPP/%{name} pax-exam-junit-extender-impl
install -m 644 pax-exam-junit-extender-impl/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-pax-exam-junit-extender-impl.pom
install -m 644 pax-exam-junit-extender-impl/target/pax-exam-junit-extender-impl-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/

%add_to_maven_depmap org.ops4j.pax.exam pax-exam-junit-extender %{version} JPP/%{name} pax-exam-junit-extender
install -m 644 pax-exam-junit-extender/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-pax-exam-junit-extender.pom
install -m 644 pax-exam-junit-extender/target/pax-exam-junit-extender-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/

%add_to_maven_depmap org.ops4j.pax.exam pax-exam-junit %{version} JPP/%{name} pax-exam-junit
install -m 644 pax-exam-junit/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-pax-exam-junit.pom
install -m 644 pax-exam-junit/target/pax-exam-junit-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/

%add_to_maven_depmap org.ops4j.pax.exam pax-exam-runtime %{version} JPP/%{name} pax-exam-runtime
install -m 644 pax-exam-runtime/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-pax-exam-runtime.pom
install -m 644 pax-exam-runtime/target/pax-exam-runtime-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/

%add_to_maven_depmap org.ops4j.pax.exam pax-exam-spi %{version} JPP/%{name} pax-exam-spi
install -m 644 pax-exam-spi/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-pax-exam-spi.pom
install -m 644 pax-exam-spi/target/pax-exam-spi-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/

%add_to_maven_depmap org.ops4j.pax.exam pax-exam %{version} JPP/%{name} pax-exam
install -m 644 pax-exam/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-pax-exam.pom
install -m 644 pax-exam/target/pax-exam-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/

%add_to_maven_depmap org.ops4j.pax.exam pax-exam-testng %{version} JPP/%{name} pax-exam-testng
install -m 644 pax-exam-testng/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-pax-exam-testng.pom
install -m 644 pax-exam-testng/target/pax-exam-testng-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/

(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(-,root,root)
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/*.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*

%files javadoc
%defattr(-,root,root,-)
%doc %{_javadocdir}/*

%changelog
* Mon Jun 27 2011 Ralph Apel <r.apel at r-apel.de> 0:1.2.0-1
- First release
